diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/link-template.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/link-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/link-template.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/link-template.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 2043,2050 ****
  	else
  		$url = WP_PLUGIN_URL;
  
! 	if ( 0 === strpos($url, 'http') && is_ssl() )
! 		$url = str_replace( 'http://', 'https://', $url );
  
  	if ( !empty($plugin) && is_string($plugin) ) {
  		$folder = dirname(plugin_basename($plugin));
--- 2071,2078 ----
  	else
  		$url = WP_PLUGIN_URL;
  
! 
! 	$url = set_url_scheme( $url );
  
  	if ( !empty($plugin) && is_string($plugin) ) {
  		$folder = dirname(plugin_basename($plugin));
***************
*** 2069,2104 ****
   * @since 3.0.0
   *
   * @param string $path Optional. Path relative to the site url.
!  * @param string $scheme Optional. Scheme to give the site url context. Currently 'http', 'https', 'login', 'login_post', 'admin', or 'relative'.
   * @return string Site url link with optional path appended.
  */
  function network_site_url( $path = '', $scheme = null ) {
  	global $current_site;
  
! 	if ( !is_multisite() )
  		return site_url($path, $scheme);
  
- 	$orig_scheme = $scheme;
- 	if ( !in_array( $scheme, array( 'http', 'https', 'relative' ) ) ) {
- 		if ( ( 'login_post' == $scheme || 'rpc' == $scheme ) && ( force_ssl_login() || force_ssl_admin() ) )
- 			$scheme = 'https';
- 		elseif ( ('login' == $scheme) && ( force_ssl_admin() ) )
- 			$scheme = 'https';
- 		elseif ( ('admin' == $scheme) && force_ssl_admin() )
- 			$scheme = 'https';
- 		else
- 			$scheme = ( is_ssl() ? 'https' : 'http' );
- 	}
- 
  	if ( 'relative' == $scheme )
  		$url = $current_site->path;
  	else
! 		$url = $scheme . '://' . $current_site->domain . $current_site->path;
  
! 	if ( !empty($path) && is_string($path) && strpos($path, '..') === false )
! 		$url .= ltrim($path, '/');
  
! 	return apply_filters('network_site_url', $url, $path, $orig_scheme);
  }
  
  /**
--- 2097,2120 ----
   * @since 3.0.0
   *
   * @param string $path Optional. Path relative to the site url.
!  * @param string $scheme Optional. Scheme to give the site url context. See set_url_scheme().
   * @return string Site url link with optional path appended.
  */
  function network_site_url( $path = '', $scheme = null ) {
  	global $current_site;
  
! 	if ( ! is_multisite() )
  		return site_url($path, $scheme);
  
  	if ( 'relative' == $scheme )
  		$url = $current_site->path;
  	else
! 		$url = set_url_scheme( 'http://' . $current_site->domain . $current_site->path, $scheme );
  
! 	if ( ! empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
! 		$url .= ltrim( $path, '/' );
  
! 	return apply_filters( 'network_site_url', $url, $path, $scheme );
  }
  
  /**
***************
*** 2118,2137 ****
  function network_home_url( $path = '', $scheme = null ) {
  	global $current_site;
  
! 	if ( !is_multisite() )
  		return home_url($path, $scheme);
  
  	$orig_scheme = $scheme;
  
! 	if ( !in_array( $scheme, array( 'http', 'https', 'relative' ) ) )
! 		$scheme = is_ssl() && !is_admin() ? 'https' : 'http';
  
  	if ( 'relative' == $scheme )
  		$url = $current_site->path;
  	else
! 		$url = $scheme . '://' . $current_site->domain . $current_site->path;
  
! 	if ( !empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= ltrim( $path, '/' );
  
  	return apply_filters( 'network_home_url', $url, $path, $orig_scheme);
--- 2134,2153 ----
  function network_home_url( $path = '', $scheme = null ) {
  	global $current_site;
  
! 	if ( ! is_multisite() )
  		return home_url($path, $scheme);
  
  	$orig_scheme = $scheme;
  
! 	if ( ! in_array( $scheme, array( 'http', 'https', 'relative' ) ) )
! 		$scheme = is_ssl() && ! is_admin() ? 'https' : 'http';
  
  	if ( 'relative' == $scheme )
  		$url = $current_site->path;
  	else
! 		$url = set_url_scheme( 'http://' . $current_site->domain . $current_site->path, $scheme );
  
! 	if ( ! empty( $path ) && is_string( $path ) && strpos( $path, '..' ) === false )
  		$url .= ltrim( $path, '/' );
  
  	return apply_filters( 'network_home_url', $url, $path, $orig_scheme);
***************
*** 2302,2307 ****
--- 2318,2327 ----
  		return;
  
  	$link = get_permalink( $id );
+ 
+ 	if ( $page = get_query_var('cpage') )
+ 		$link = get_comments_pagenum_link( $page );
+ 
  	echo "<link rel='canonical' href='$link' />\n";
  }
  
***************
*** 2401,2407 ****
   * @param string $after Optional HTML to display after the link.
   */
  function the_shortlink( $text = '', $title = '', $before = '', $after = '' ) {
! 	global $post;
  
  	if ( empty( $text ) )
  		$text = __('This is the short link.');
--- 2421,2427 ----
   * @param string $after Optional HTML to display after the link.
   */
  function the_shortlink( $text = '', $title = '', $before = '', $after = '' ) {
! 	$post = get_post();
  
  	if ( empty( $text ) )
  		$text = __('This is the short link.');
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/load.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/load.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/load.php	2012-10-29 12:35:30.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/load.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 356,362 ****
  		dead_db();
  
  	$wpdb->field_types = array( 'post_author' => '%d', 'post_parent' => '%d', 'menu_order' => '%d', 'term_id' => '%d', 'term_group' => '%d', 'term_taxonomy_id' => '%d',
! 		'parent' => '%d', 'count' => '%d','object_id' => '%d', 'term_order' => '%d', 'ID' => '%d', 'commment_ID' => '%d', 'comment_post_ID' => '%d', 'comment_parent' => '%d',
  		'user_id' => '%d', 'link_id' => '%d', 'link_owner' => '%d', 'link_rating' => '%d', 'option_id' => '%d', 'blog_id' => '%d', 'meta_id' => '%d', 'post_id' => '%d',
  		'user_status' => '%d', 'umeta_id' => '%d', 'comment_karma' => '%d', 'comment_count' => '%d',
  		// multisite:
--- 356,362 ----
  		dead_db();
  
  	$wpdb->field_types = array( 'post_author' => '%d', 'post_parent' => '%d', 'menu_order' => '%d', 'term_id' => '%d', 'term_group' => '%d', 'term_taxonomy_id' => '%d',
! 		'parent' => '%d', 'count' => '%d','object_id' => '%d', 'term_order' => '%d', 'ID' => '%d', 'comment_ID' => '%d', 'comment_post_ID' => '%d', 'comment_parent' => '%d',
  		'user_id' => '%d', 'link_id' => '%d', 'link_owner' => '%d', 'link_rating' => '%d', 'option_id' => '%d', 'blog_id' => '%d', 'meta_id' => '%d', 'post_id' => '%d',
  		'user_status' => '%d', 'umeta_id' => '%d', 'comment_karma' => '%d', 'comment_count' => '%d',
  		// multisite:
***************
*** 381,387 ****
   * @since 3.0.0
   */
  function wp_start_object_cache() {
! 	global $_wp_using_ext_object_cache;
  
  	$first_init = false;
   	if ( ! function_exists( 'wp_cache_init' ) ) {
--- 381,387 ----
   * @since 3.0.0
   */
  function wp_start_object_cache() {
! 	global $_wp_using_ext_object_cache, $blog_id;
  
  	$first_init = false;
   	if ( ! function_exists( 'wp_cache_init' ) ) {
***************
*** 403,415 ****
  	// If cache supports reset, reset instead of init if already initialized.
  	// Reset signals to the cache that global IDs have changed and it may need to update keys
  	// and cleanup caches.
! 	if ( !$first_init && function_exists('wp_cache_reset') )
! 		wp_cache_reset();
  	else
  		wp_cache_init();
  
  	if ( function_exists( 'wp_cache_add_global_groups' ) ) {
! 		wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts' ) );
  		wp_cache_add_non_persistent_groups( array( 'comment', 'counts', 'plugins' ) );
  	}
  }
--- 403,415 ----
  	// If cache supports reset, reset instead of init if already initialized.
  	// Reset signals to the cache that global IDs have changed and it may need to update keys
  	// and cleanup caches.
! 	if ( ! $first_init && function_exists( 'wp_cache_switch_to_blog' ) )
! 		wp_cache_switch_to_blog( $blog_id );
  	else
  		wp_cache_init();
  
  	if ( function_exists( 'wp_cache_add_global_groups' ) ) {
! 		wp_cache_add_global_groups( array( 'users', 'userlogins', 'usermeta', 'user_meta', 'site-transient', 'site-options', 'site-lookup', 'blog-lookup', 'blog-details', 'rss', 'global-posts', 'blog-id-cache' ) );
  		wp_cache_add_non_persistent_groups( array( 'comment', 'counts', 'plugins' ) );
  	}
  }
***************
*** 583,590 ****
   * @return bool True if inside WordPress administration pages.
   */
  function is_admin() {
! 	if ( defined( 'WP_ADMIN' ) )
  		return WP_ADMIN;
  	return false;
  }
  
--- 583,593 ----
   * @return bool True if inside WordPress administration pages.
   */
  function is_admin() {
! 	if ( isset( $GLOBALS['current_screen'] ) )
! 		return $GLOBALS['current_screen']->in_admin();
! 	elseif ( defined( 'WP_ADMIN' ) )
  		return WP_ADMIN;
+ 
  	return false;
  }
  
***************
*** 599,606 ****
   * @return bool True if inside WordPress network administration pages.
   */
  function is_blog_admin() {
! 	if ( defined( 'WP_BLOG_ADMIN' ) )
  		return WP_BLOG_ADMIN;
  	return false;
  }
  
--- 602,612 ----
   * @return bool True if inside WordPress network administration pages.
   */
  function is_blog_admin() {
! 	if ( isset( $GLOBALS['current_screen'] ) )
! 		return $GLOBALS['current_screen']->in_admin( 'site' );
! 	elseif ( defined( 'WP_BLOG_ADMIN' ) )
  		return WP_BLOG_ADMIN;
+ 
  	return false;
  }
  
***************
*** 615,622 ****
   * @return bool True if inside WordPress network administration pages.
   */
  function is_network_admin() {
! 	if ( defined( 'WP_NETWORK_ADMIN' ) )
  		return WP_NETWORK_ADMIN;
  	return false;
  }
  
--- 621,631 ----
   * @return bool True if inside WordPress network administration pages.
   */
  function is_network_admin() {
! 	if ( isset( $GLOBALS['current_screen'] ) )
! 		return $GLOBALS['current_screen']->in_admin( 'network' );
! 	elseif ( defined( 'WP_NETWORK_ADMIN' ) )
  		return WP_NETWORK_ADMIN;
+ 
  	return false;
  }
  
***************
*** 631,638 ****
   * @return bool True if inside WordPress user administration pages.
   */
  function is_user_admin() {
! 	if ( defined( 'WP_USER_ADMIN' ) )
  		return WP_USER_ADMIN;
  	return false;
  }
  
--- 640,650 ----
   * @return bool True if inside WordPress user administration pages.
   */
  function is_user_admin() {
! 	if ( isset( $GLOBALS['current_screen'] ) )
! 		return $GLOBALS['current_screen']->in_admin( 'user' );
! 	elseif ( defined( 'WP_USER_ADMIN' ) )
  		return WP_USER_ADMIN;
+ 
  	return false;
  }
  
***************
*** 654,659 ****
--- 666,683 ----
  }
  
  /**
+  * Retrieve the current blog id
+  *
+  * @since 3.1.0
+  *
+  * @return int Blog id
+  */
+ function get_current_blog_id() {
+ 	global $blog_id;
+ 	return absint($blog_id);
+ }
+ 
+ /**
   * Attempts an early load of translations.
   *
   * Used for errors encountered during the initial loading process, before the locale has been
